;ONEFIX.M
; This module constructs zonal and meridionalwindfield components for exactly one  fix

;... put purely radial functions on a polar grid
@genstrex.m

;...form storm-relative windfield
cfu=[0,0] & cfsg=[0,0] & scl=.01*[1,1]
udvs,cfu & sgdvs,cfsg

;my stuff here
;print,'before ameoba  cfu',cfu,' cfsg ',cfsg,ii
;
;...determine form factors
cfu=AMOEBA(1.e-6,p0=cfu,scale=scl,function_value=rsu,function_name='MNRDU')
;print,'after ameoba 1  cfu',cfu,' rsu ',rsu,ii
cfsg=AMOEBA(1.e-6,p0=cfsg,scale=scl,function_value=rssg,function_name='MNRDSG')
;print,'after ameoba 1  cfsg',cfsg,' rssg ',rssg,ii
cfu=AMOEBA(1.e-6,p0=cfu,scale=scl,function_value=rsu,function_name='MNRDU')
;print,'after ameoba 2  cfu',cfu,' rsu ',rsu,ii
cfsg=AMOEBA(1.e-6,p0=cfsg,scale=scl,function_value=rssg,function_name='MNRDSG')
;print,'after ameoba 2  cfsg',cfsg,' rssg ',rssg,ii
cfu=AMOEBA(1.e-6,p0=cfu,scale=scl,function_value=rsu,function_name='MNRDU')
;print,'after ameoba 3  cfu',cfu,' rsu ',rsu,ii
cfsg=AMOEBA(1.e-6,p0=cfsg,scale=scl,function_value=rssg,function_name='MNRDSG')
;print,'after ameoba 3  cfsg',cfsg,' rssg ',rssg,ii
;print,cfu & print,cfsg & print,rsu & print,rssg

;...form earth relative windfield
vstre=vgstre+sgstre
uerstre=ustre+c*snstre & verstre=vstre+c*csstre
zerstre=complex(uerstre,verstre)

;...advance phase of wind maximum according to gradient wind profile
werstre=float(sqrt(zerstre*conj(zerstre)))
iwx=where(werstre eq max(werstre)) & iwx=iwx(0)
adisp=-180*atan(ynstre(iwx),xnstre(iwx))/!pi
twist= -adisp*vgstre+brg

;...orient windfield to track direction
j=complex(0,1) & rotor=exp(!pi*j*twist/180)
znstre=rotor*complex(xnstre,ynstre)
rxnstre=float(znstre) & rynstre=imaginary(znstre)
sdx=10*sstre & odx=18*(atan(rynstre,rxnstre)/!pi+1)+1
sdx(0,*)=0. & odx(0,*)=odx(150,*)
zerstre=interpolate(zerstre,sdx,odx,cubic=-.5)
;zerstre(0,*,*)=complex(0,0)
@shift.m
uerstre=float(zerstre) & verstre=imaginary(zerstre)

;...final e.r. surface wind on polar grid
uxstre=uerstre*csstre-verstre*snstre
vystre=uerstre*snstre+verstre*csstre
zxystre=complex(uxstre,vystre)
;END ONEFIX.M
