PRO USG,s,sg,u,v,w,vg,d2vg,gg,d2gg,dd,d2dd,alpha,iw
compile_opt hidden
on_error,1

;...preamble
if n_params() eq 0 then begin
print,'USG,s,sg,u,v,w,vg,d2vg,gg,d2gg,dd,d2dd,alpha,iw'
return&endif

;... initialize outer boundary values
jxx=n_elements(s) & jx=jxx-1 & beta=.132653
uj=0. & sgj=0. & j=jx
@obc.m
sinw=s(jx) & uinw=uj & sginw=sgj 
COMMON GRAD,vn,dz,gz,d2vn,d2d,d2g,sz
vn=vg & dz=dd & gz=gg & d2vn=d2vg & d2d=d2dd & d2g=d2gg & sz=s
COMMON DUSG,h,alf & h=-.1 & alf=alpha
status=2 & x=sinw & z=[uinw,sginw]

;...numerically integrate momentum equations for stationary storm profiles
for j=1,jx do begin 
if status ge 0 then z=LSODE(z,x,h,'DUS',status,ATOL=1e-3,RTOL=1e-3) & x=x+h 
sinw=[x,sinw] & uinw=[z(0),uinw] & sginw=[z(1),sginw] &endfor
iu=where(uinw eq max(uinw(5:15))) & isg=where(sginw eq max(sginw(5:15)))
io=max(isg) & ;print,io

;...gradient balance in the eye

;... match solutions across the shock
uz=fltarr(201) & uz(io:*)=uinw(io:*)
sgz=fltarr(201) & sgz(io:*)=sginw(io:*)
uz=-abs(uz)

;... subgrid smoothing process simulates turbulent diffusion
s3=indgen(3*jx+1)/30.
d2uz=spl_init(s,uz,yp0=0.) & d2sgz=spl_init(s,sgz,yp0=0.)
uz3=spl_interp(s,uz,d2uz,s3) & sgz3=spl_interp(s,sgz,d2sgz,s3)
for i=1,20 do begin sgz3=smooth(sgz3,3) & uz3=smooth(uz3,3) &endfor

;... subsample to recover original resolution
u=uz3(0:*:3) & sg=sgz3(0:*:3)
v=vg+sg & w=sqrt(u^2+v^2)

;...determine peak wind radial position
iw=where(w eq max(w)) & iw=iw(0)
;print,iw
END ;USG.PRO
